"""
Convert a TGA map from PGU leveledit format.

Requires pygame.
"""

import pygame

ROOM_TW, ROOM_TH = 16, 12

def convert(filename, outfile):
    f = open(outfile, "wt")

    img = pygame.image.load(filename)
    w,h = img.get_size()

    nx,ny = w//ROOM_TW, h//ROOM_TH

    print >>f, "# room maps"
    print >>f
    print >>f, "width, height = %d, %d" % (nx,ny)
    print >>f
    print >>f, "rooms = ["
    print >>f

    for ry in xrange(0,h-(ROOM_TH-1),ROOM_TH):
        for rx in xrange(0,w-(ROOM_TW-1),ROOM_TW):
            tiles = [[0]*ROOM_TW for y in xrange(0,ROOM_TH)]
            codes = [[0]*ROOM_TW for y in xrange(0,ROOM_TH)]
            for y in xrange(0,ROOM_TH):
                for x in xrange(0,ROOM_TW):
                    r,g,b,a = img.get_at((rx+x,ry+y))
                    tiles[y][x] = r
                    codes[y][x] = b
            print >>f, "    # room %d,%d" % (rx/ROOM_TW,ry/ROOM_TH)
            print >>f, "    ["
            for row in tiles:
                print >>f, "        [%s]," % ",".join(str(x) for x in row)
            print >>f, "    ],"
            print >>f, "    ["
            for row in codes:
                print >>f, "        [%s]," % ",".join(str(x) for x in row)
            print >>f, "    ],"

    print >>f
    print >>f, "]"
    f.close()


if __name__ == '__main__':
    convert("data/map.tga", "rooms.py")
